CMSIS-DSP: Complex-by-Complex Multiplication

| CMSIS-DSP Version 1.7.0 CMSIS DSP Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
Complex-by-Complex Multiplication
Complex Math Functions

## Functions
void | arm_cmplx_mult_cmplx_f32 (const float32_t *pSrcA, const float32_t *pSrcB, float32_t *pDst, uint32_t numSamples)
| Floating-point complex-by-complex multiplication. More...
void | arm_cmplx_mult_cmplx_q15 (const q15_t *pSrcA, const q15_t *pSrcB, q15_t *pDst, uint32_t numSamples)
| Q15 complex-by-complex multiplication. More...
void | arm_cmplx_mult_cmplx_q31 (const q31_t *pSrcA, const q31_t *pSrcB, q31_t *pDst, uint32_t numSamples)
| Q31 complex-by-complex multiplication. More...

## Description

Multiplies a complex vector by another complex vector and generates a complex result. The data in the complex arrays is stored in an interleaved fashion (real, imag, real, imag, ...). The parameter `numSamples` represents the number of complex samples processed. The complex arrays have a total of `2*numSamples` real values.

The underlying algorithm is used:

    for (n = 0; n < numSamples; n++) {
        pDst[(2*n)+0] = pSrcA[(2*n)+0] * pSrcB[(2*n)+0] - pSrcA[(2*n)+1] * pSrcB[(2*n)+1];
        pDst[(2*n)+1] = pSrcA[(2*n)+0] * pSrcB[(2*n)+1] + pSrcA[(2*n)+1] * pSrcB[(2*n)+0];
    }

There are separate functions for floating-point, Q15, and Q31 data types.

## Function Documentation

void arm_cmplx_mult_cmplx_f32 | ( | const float32_t * | pSrcA,
|  | const float32_t * | pSrcB,
|  | float32_t * | pDst,
|  | uint32_t | numSamples
| ) |  |

Parameters

  [in] | pSrcA | points to first input vector
  [in] | pSrcB | points to second input vector
  [out] | pDst | points to output vector
  [in] | numSamples | number of samples in each vector

Returns
  none

void arm_cmplx_mult_cmplx_q15 | ( | const q15_t * | pSrcA,
|  | const q15_t * | pSrcB,
|  | q15_t * | pDst,
|  | uint32_t | numSamples
| ) |  |

Parameters

  [in] | pSrcA | points to first input vector
  [in] | pSrcB | points to second input vector
  [out] | pDst | points to output vector
  [in] | numSamples | number of samples in each vector

Returns
  none

Scaling and Overflow Behavior
  The function implements 1.15 by 1.15 multiplications and finally output is converted into 3.13 format.

void arm_cmplx_mult_cmplx_q31 | ( | const q31_t * | pSrcA,
|  | const q31_t * | pSrcB,
|  | q31_t * | pDst,
|  | uint32_t | numSamples
| ) |  |

Parameters

  [in] | pSrcA | points to first input vector
  [in] | pSrcB | points to second input vector
  [out] | pDst | points to output vector
  [in] | numSamples | number of samples in each vector

Returns
  none

Scaling and Overflow Behavior
  The function implements 1.31 by 1.31 multiplications and finally output is converted into 3.29 format. Input down scaling is not required.